<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="试题类型" prop="cqQuestType">
        <el-select
          v-model="queryParams.cqQuestType"
          placeholder="请选择试题类型"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.COURSE_QUESTION_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="试题内容" prop="cqQuestion">
        <el-input
          v-model="queryParams.cqQuestion"
          placeholder="请输入试题内容"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['bjdx:course-question:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['bjdx:course-question:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
<!--      <el-table-column label="试题id" align="center" prop="id" width="100px"/>-->
      <el-table-column label="试题类型" align="center" prop="cqQuestType" width="120px">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.COURSE_QUESTION_TYPE" :value="scope.row.cqQuestType" />
        </template>
      </el-table-column>
      <el-table-column label="试题内容" align="center" prop="cqQuestion" >
        <template #default="scope">
          <div v-html="scope.row.cqQuestion"></div>
        </template>
      </el-table-column>
      <el-table-column label="试题解析" align="center" prop="cqQuestAnalysis" >
        <template #default="scope">
          <div v-html="scope.row.cqQuestAnalysis"></div>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" min-width="120px">
        <template #default="scope">
          <el-button
            link
            type="primary"
            v-if="scope.row.tenantId == getTenantId()"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['bjdx:course-question:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            v-if="scope.row.tenantId == getTenantId()"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['bjdx:course-question:delete']"
          >
            删除
          </el-button>
          <el-button
            link
            type="info"
            @click="goToOptionList(scope.row.id, scope.row.cqQuestion,scope.row.tenantId)"
            v-hasPermi="['bjdx:course-question:update']"
          >
            选项列表
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <CourseQuestionForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import download from '@/utils/download'
import { CourseQuestionApi, CourseQuestionVO } from '@/api/bjdx/coursequestion'
import CourseQuestionForm from './CourseQuestionForm.vue'
import { DICT_TYPE, getStrDictOptions } from '@/utils/dict'
import { useRouter } from 'vue-router'
import { getTenantId } from '@/utils/auth'
import { ElButton } from 'element-plus'

/** 课程-试题 列表 */
defineOptions({ name: 'CourseQuestion' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<CourseQuestionVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  cqQuestion: undefined,
  cqQuestAnalysis: undefined,
  cqQuestType: undefined,
  cqQuestAnswerId: undefined
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {

    const data = await CourseQuestionApi.getCourseQuestionPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await CourseQuestionApi.deleteCourseQuestion(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await CourseQuestionApi.exportCourseQuestion(queryParams)
    download.excel(data, '课程-试题.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})

const router = useRouter()

// 跳转选项列表页
const goToOptionList = (id: number, question: String,tenantId: number) => {
  router.push({
    name: 'questOption',
    query: { questId: id , question: question,tenantId: tenantId}
  })
}
</script>
